/* 
 * File:   EEPROM_Functions.h
 * Author: rmcnamee
 *
 * Created on January 12, 2018, 1:42 PM
 */

#ifndef EEPROM_FUNCTIONS_H
#define	EEPROM_FUNCTIONS_H

/**
   @Param
    none
   @Returns
    none
   @Description
    Provides any setup needed for the EEPROM
   @Example
    SetupEEPROM();
 */
void SetupEEPROM(void);

/**
   @Param
    none
   @Returns
    The dev kit mode saved in EEPROM
   @Description
    There are 4 different OLED development kits, so which one is selected is
 * saved to EEPROM so it can be recalled later
   @Example
 devKitTypeEnum devKit = ReadDevKitFromEeprom();
 */
devKitTypeEnum ReadDevKitFromEeprom(void);

/**
   @Param
    The dev kit to save to EEPROm
   @Returns
    none
   @Description
    There are 4 different OLED development kits, so which one is selected needs to be
 * saved to EEPROM so it can be recalled later
   @Example
 WriteDevKitToEeprom(DEV_KIT_TWO_FRAMELESS);
 */
void WriteDevKitToEeprom(devKitTypeEnum kit);


#endif	/* EEPROM_FUNCTIONS_H */

